local raceTimer = 0
local pulse = 0
local row = 0

local function hud_render()

    -- Reload Message
    if gGlobalSyncTable.reload then
        djui_hud_set_color(255, 255, 255, 255)
        djui_hud_print_text("Reloading Course...", (djui_hud_get_screen_width() / 2)-(djui_hud_measure_text("Reloading Level...") * 4/2), (djui_hud_get_screen_height() / 2) - 60, 4)
    end

end

local function hud_render_behind()

    -- Hide Normal HUD
    hud_hide()

    -- Initialize
    djui_hud_set_resolution(RESOLUTION_DJUI)
    djui_hud_set_font(0)
    
    if gGlobalSyncTable.level == 0 then -- INTERMISSION

        -- Title
        row = 24
        djui_hud_set_font(2)
        fancy_text("Quickplay", "middle", 4, row, 6, 255, 255, 255, 255, false)
        row = row + 128

        
        djui_hud_set_font(0)

        -- Level Select
        if gGlobalSyncTable.levelIndex == 0 then
            fancy_text("< " .. "All Courses" .. " >", "middle", 4, row, 2, 255, 128, 255, 255, true)
        else
            local uiR, uiG, uiB = 64, 240, 240
            if levels[gGlobalSyncTable.levelIndex][2] <= 15 then uiR, uiG, uiB = 255, 255, 64 end
            if levels[gGlobalSyncTable.levelIndex][2] >= 16 and levels[gGlobalSyncTable.levelIndex][2] <= 18 then uiR, uiG, uiB = 255, 160, 64 end
            if levels[gGlobalSyncTable.levelIndex][2] == 20 then uiR, uiG, uiB = 64, 224, 64 end
            if levels[gGlobalSyncTable.levelIndex][2] == 21 then uiR, uiG, uiB = 255, 96, 96 end
            if levels[gGlobalSyncTable.levelIndex][2] == 22 then uiR, uiG, uiB = 128, 128, 255 end
            fancy_text("< " .. gGlobalSyncTable.levelIndex .. ". " .. get_level_name(levels[gGlobalSyncTable.levelIndex][2], 1, 1).. " >", "middle", 4, row, 2, uiR, uiG, uiB, 255, true)
        end
        row = row + 70

        if network_is_server() then

            -- Solo Record
            if mod_storage_load(game .. gGlobalSyncTable.levelIndex) ~= nil then
                fancy_text("Solo Record: " .. convert_time(mod_storage_load(game .. gGlobalSyncTable.levelIndex), "speedrun"), "middle", 4, row, 2, 255, 255, 255, 255, true)
            else
                fancy_text("No Solo Record", "middle", 4, row, 2, 255, 255, 255, 255, true)
            end
            row = row + 70

            -- Press Y to Start
            fancy_text("Press Y to Start", "middle", 4, row, 2, 255, 255, 255, 255, true)

            if players < 2 then
                fancy_text("Single-Player Warning", "middle", 4, djui_hud_get_screen_height()-270, 2, 255, 96, 96, 255, true)
                fancy_text("If you Exit Course or Die...", "middle", 4, djui_hud_get_screen_height()-200, 2, 255, 96, 96, 255, true)
                fancy_text("Coins, Red Coins, and Secrets will reset!", "middle", 4, djui_hud_get_screen_height()-140, 2, 255, 96, 96, 255, true)
            end

        else
            --Waiting for Host
            fancy_text("Waiting for Host...", "middle", 4, row, 2, 255, 255, 255, 255, true)
        end

        -- Player List
        djui_hud_set_color(0, 0, 0, 192)
        djui_hud_render_rect(0, 0, 200, players*30 + 30)
        fancy_text("Players: " .. players, "left", 4, 0, 1, 255, 255, 255, 255, false, 0, false, false)
        row = 30
        for i=0, MAX_PLAYERS-1 do
            if gNetworkPlayers[i].connected then
                local r, g, b = hex_to_rgb(network_get_player_text_color_string(i))
                fancy_text(shorten_name(string_without_hex(gNetworkPlayers[i].name)), "left", 4, row, 1, r, g, b, 255, false, 0, 0, 0, 0)
                row = row + 30
            end
        end

    else -- ACTIVE ROUND

        -- Control Guide
        if network_is_server() then
            fancy_text("D-Pad Up               ", "left", djui_hud_get_screen_width()-240, djui_hud_get_screen_height()-60, 1, 255, 255, 255, 255, true)
            fancy_text("= Reload", "left", djui_hud_get_screen_width()-104, djui_hud_get_screen_height()-60, 1, 255, 255, 255, 255, false)
            fancy_text("D-Pad Down               ", "left", djui_hud_get_screen_width()-240, djui_hud_get_screen_height()-30, 1, 255, 255, 255, 255, true)
            fancy_text("= Quit", "left", djui_hud_get_screen_width()-104, djui_hud_get_screen_height()-30, 1, 255, 255, 255, 255, false)
        end

        -- Reload/Quit Splash
        if
            network_is_server() and
            gGlobalSyncTable.level > 0 and
            autoRepeat > 0
        then
            fancy_text(autoRepeatMessage, "middle", 4, 60, 2, 255, 255, 255, autoRepeat*15, true, 0, 0, 0, autoRepeat*10)
        end
        
        -- Top Left Rectangle
        row = 0
        local rectHeight = 60
        local rectWidth = djui_hud_measure_text(convert_time(gGlobalSyncTable.timer, "speedrun") .. "    " .. players .. " Players")
        if rectWidth < djui_hud_measure_text(get_level_name(levels[gGlobalSyncTable.level][2], 1, 1)) then
            rectWidth = djui_hud_measure_text(get_level_name(levels[gGlobalSyncTable.level][2], 1, 1))
        end
        if rectWidth < djui_hud_measure_text(get_level_name(levels[gGlobalSyncTable.level][2], 1, 1)) then
            rectWidth = djui_hud_measure_text(get_level_name(levels[gGlobalSyncTable.level][2], 1, 1))
        end
        for i = 1, levels[gGlobalSyncTable.level][3] do
            if rectWidth < djui_hud_measure_text(get_star_name(levels[gGlobalSyncTable.level][2], i)) then
                rectWidth = djui_hud_measure_text(get_star_name(levels[gGlobalSyncTable.level][2], i))
            end
            rectHeight = rectHeight + 30
        end
        rectWidth = rectWidth + 8
        djui_hud_set_color(0, 0, 0, 192)
        djui_hud_render_rect(0, 0, rectWidth, rectHeight)

        -- Speedrun Timer
        if players > 1 then
            fancy_text(convert_time(gGlobalSyncTable.timer, "speedrun") .. "    " .. players .. " Players", "left", 4, row, 1, 255, 255, 255, 255, false)
        else
            fancy_text(convert_time(gGlobalSyncTable.timer, "speedrun") .. "    " .. players .. " Player", "left", 4, row, 1, 255, 255, 255, 255, false)
        end
        row = row + 30

        -- Level Name
        fancy_text(get_level_name(levels[gGlobalSyncTable.level][2], 1, 1), "left", 4, row, 1, 192, 192, 255, 255, false)
        row = row + 30

        -- Star List
        for i = 0, levels[gGlobalSyncTable.level][3]-1 do
            if save_file_get_star_flags(get_current_save_file_num() - 1, levels[gGlobalSyncTable.level][2]-1) & (1 << i) ~= 0 then
                fancy_text(get_star_name(levels[gGlobalSyncTable.level][2], i+1), "left", 4, row, 1, 128, 255, 128, 255, false)
            else
                fancy_text(get_star_name(levels[gGlobalSyncTable.level][2], i+1), "left", 4, row, 1, 255, 128, 128, 255, false)
                -- Chuckya Harbor Hint
                if game == "star-road" and i == 5 and gGlobalSyncTable.level == 4 then
                    fancy_text("Stand in front of the \"L is Real\" Plaque", "left", rectWidth+4, 210, 1, 255, 255, 255, 255, true)
                end
            end
            row = row + 30
        end
        row = row + 10

        -- Cannon Text
        if
            gMarioStates[0].action == ACT_IN_CANNON and
            gMarioStates[0].actionState == 2 and
            players > 1
        then
            fancy_text("Shooting in " .. math.floor((300-cannonTimer) / 30) + 1, "middle", 0, djui_hud_get_screen_height()-120, 3, 255, 255, 255, 255, false, 255, 255, 255, 255)
        end

        -- Coins
        djui_hud_set_font(2)
        if
            levels[gGlobalSyncTable.level][2] >= 1 and 
            levels[gGlobalSyncTable.level][2] <= 15 
        then
            djui_hud_set_color(255, 255, 255, 255)
            djui_hud_print_text("$", 8, row, 4)
            djui_hud_print_text(tostring(hud_get_value(HUD_DISPLAY_COINS)), 84, row, 4)
            djui_hud_set_color(255, 0, 0, 255)
            row = row + 72
        end
        
        -- Red Coins
        if obj_count_objects_with_behavior_id(id_bhvRedCoin) > 0 then
            djui_hud_set_color(255, 0, 0, 255)
            djui_hud_print_text("$", 8, row, 4)
            djui_hud_set_color(255, 255, 255, 255)
            djui_hud_print_text(tostring(gMarioStates[0].area.numRedCoins - obj_count_objects_with_behavior_id(id_bhvRedCoin)), 84, row, 4)
            row = row + 72
        end

        -- Secrets
        if obj_count_objects_with_behavior_id(id_bhvHiddenStarTrigger) > 0 then
            djui_hud_set_color(255, 255, 255, 255)
            djui_hud_render_texture(gTextures.lakitu, 8, row, 4, 4)
            djui_hud_set_color(255, 255, 255, 255)
            djui_hud_print_text(tostring(5 - obj_count_objects_with_behavior_id(id_bhvHiddenStarTrigger)), 84, row, 4)
            row = row + 72
        end
        
        -- Race Timer
        if hud_get_value(HUD_DISPLAY_TIMER) > raceTimer then
            djui_hud_set_color(255, 255, 255, 255)
            djui_hud_print_text(convert_time(hud_get_value(HUD_DISPLAY_TIMER), "race"), djui_hud_get_screen_width() - 4*(75+3), djui_hud_get_screen_height() - 4*(16+3), 4)
            djui_hud_print_text("'", djui_hud_get_screen_width() - 4*(62+3), djui_hud_get_screen_height() - 4*(23+3), 4)
            djui_hud_print_text("\"", djui_hud_get_screen_width() - 4*(27+3), djui_hud_get_screen_height() - 4*(23+3), 4)
        end
        raceTimer = hud_get_value(HUD_DISPLAY_TIMER)

        -- Power Meter
        djui_hud_set_color(255, 255, 255, 255)
        hud_render_power_meter(gMarioStates[0].health, djui_hud_get_screen_width() - 256, 0, 256, 256)

    end

end

-- Fancy Text
function fancy_text(text, margin, xpos, ypos, size, r, g, b, a, rect)

    if margin == "middle" then
        xpos = djui_hud_get_screen_width()/2 - (djui_hud_measure_text(text) * size)/2
    end

    if margin == "right" then
        xpos = djui_hud_get_screen_width() - djui_hud_measure_text(text)
    end

    if rect then
        djui_hud_set_color(0, 0, 0, 192)
        djui_hud_render_rect(xpos-4*size, ypos, (djui_hud_measure_text(text)+8)*size, 30*size)
    end

    djui_hud_set_color(0, 0, 0, 255)
    djui_hud_print_text(text, xpos+2*size, ypos+2*size, size)
    djui_hud_set_color(r, g, b, a)
    djui_hud_print_text(text, xpos, ypos, size)

end

-- Convert Time
function convert_time(time, type)
    if type == "speedrun" then
        local hours = math.floor(time / 30 / 3600 % 60)
        local minutes = math.floor(time / 30 / 60 % 60)
        local seconds = math.floor(time / 30 % 60)
        local centiseconds = math.floor(time / 30 % 1 * 100)

        if seconds < 10 then seconds = "0" .. tostring(seconds) end
        if centiseconds < 10 then centiseconds = "0" .. tostring(centiseconds) end

        if hours > 0 then
            if minutes < 10 then minutes = "0" .. tostring(minutes) end
            return(hours .. ":" .. minutes .. ":" .. seconds .. "." .. centiseconds)
        else
            return(minutes .. ":" .. seconds .. "." .. centiseconds)
        end
    elseif type == "race" then
        
        local minutes = math.floor(time / 30 / 60 % 60)
        local seconds = math.floor(time / 30 % 60)
        local centiseconds = math.floor(time / 30 % 1 * 10)
    
        if seconds < 10 then seconds = "0" .. tostring(seconds) end
    
        return(minutes .. " " .. seconds .. " " .. centiseconds)
    end

end

-- Shorten Name
function shorten_name(name)
    if string.len(name) > 15 then
        return string.sub(name, 0, 15) .. "..."
    end
    return name
end

-- Remove Hex Escape from Name
function string_without_hex(name)
    local s = ''
    local inSlash = false
    for i = 1, #name do
        local c = name:sub(i,i)
        if c == '\\' then
            inSlash = not inSlash
        elseif not inSlash then
            s = s .. c
        end
    end
    return s
end

-- Get Color Name
function hex_to_rgb(hex)
    hex = hex:gsub('#','')
	hex = hex:gsub('\\','')
    if string.len(hex) == 6 then
		return tonumber('0x'..hex:sub(1,2)), tonumber('0x'..hex:sub(3,4)), tonumber('0x'..hex:sub(5,6))
	else
		return 0, 0, 0
	end
end

hook_event(HOOK_ON_HUD_RENDER_BEHIND, hud_render_behind)
hook_event(HOOK_ON_HUD_RENDER, hud_render)