cannonTimer = 0

--- @param m MarioState
local function mario_update(m)

  local s = gPlayerSyncTable[m.playerIndex]

  if
    m.playerIndex == 0 and
    m.action == ACT_IN_CANNON and
    m.actionState == 2 and
    players > 1
  then

      cannonTimer = cannonTimer + 1

      if cannonTimer >= 300 then -- 300 is 10 seconds
          m.forwardVel = 100 * coss(m.faceAngle.x)

          m.vel.y = 100 * sins(m.faceAngle.x)

          m.pos.x = m.pos.x + 120 * coss(m.faceAngle.x) * sins(m.faceAngle.y)
          m.pos.y = m.pos.y + 120 * sins(m.faceAngle.x)
          m.pos.z = m.pos.z + 120 * coss(m.faceAngle.x) * coss(m.faceAngle.y)

          play_sound(SOUND_ACTION_FLYING_FAST, m.marioObj.header.gfx.cameraToObject)
          play_sound(SOUND_OBJ_POUNDING_CANNON, m.marioObj.header.gfx.cameraToObject)

          m.marioObj.header.gfx.node.flags = m.marioObj.header.gfx.node.flags | GRAPH_RENDER_ACTIVE
          set_camera_mode(m.area.camera, m.area.camera.defMode, 1)

          set_mario_action(m, ACT_SHOT_FROM_CANNON, 0)
          queue_rumble_data_mario(m, 60, 70)
          m.usedObj.oAction = 2
          cannonTimer = 0
      end
      
  end

  if players == 1 then
    cannonTimer = 0
  end

  if m.playerIndex == 0 and m.action == ACT_SHOT_FROM_CANNON then
      cannonTimer = 0
  end

end

hook_event(HOOK_MARIO_UPDATE, mario_update)