djui_set_popup_disabled_override(true)
gServerSettings.bubbleDeath = 1
gServerSettings.stayInLevelAfterStar = 2
gServerSettings.playerInteractions = 0
gServerSettings.bouncyLevelBounds = 0
gServerSettings.pauseAnywhere = 1
gServerSettings.skipIntro = 1
gLevelValues.disableActs = true
gLevelValues.bubbleOnDeathBarrierInCapStages = 1

coinStarDeficit = 0

local function update()

  -- Infinite Lives
  gMarioStates[0].numLives = 100

  -- 100 Coin Star Softlock Fix
  if
    network_is_server() and
    gGlobalSyncTable.level > 0 and
    players > 1 and
    levels[gGlobalSyncTable.level][2] >= 1 and
    levels[gGlobalSyncTable.level][2] <= 15 and
    hud_get_value(HUD_DISPLAY_COINS) >= gLevelValues.coinsRequiredForCoinStar and
    save_file_get_star_flags(get_current_save_file_num() - 1, levels[gGlobalSyncTable.level][2]-1) & (1 << 6) == 0
  then
    if coinStarDeficit > 30*30 then
      save_file_set_star_flags(get_current_save_file_num() - 1, levels[gGlobalSyncTable.level][2]-1, (1 << 6))
      packet_receive({packet="message", message="[Anti-Softlock]: Coin Star has been automatically collected."})
      network_send(true, {packet="message", message="[Anti-Softlock]: Coin Star has been automatically collected."})
      coinStarDeficit = 0
    else
      coinStarDeficit = coinStarDeficit + 1
    end
  else
    coinStarDeficit = 0
  end
  

  -- Skip Level Intro
  if
  (gMarioStates[0].action == ACT_SPAWN_NO_SPIN_AIRBORNE or
  gMarioStates[0].action == ACT_SPAWN_NO_SPIN_LANDING or
  gMarioStates[0].action == ACT_SPAWN_SPIN_AIRBORNE or
  gMarioStates[0].action == ACT_SPAWN_SPIN_LANDING) and
  gMarioStates[0].pos.y < gMarioStates[0].floorHeight + 10
  then
    set_mario_action(gMarioStates[0], ACT_FREEFALL, 0)
  end

  -- Skip Star Cutscene
    ---@type MarioState
    local m = gMarioStates[0]
    ---@type Camera
    local c = gMarioStates[0].area.camera

    if not m or not c then
        return
    end

    if ((c.cutscene == CUTSCENE_STAR_SPAWN) or (c.cutscene == CUTSCENE_RED_COIN_STAR_SPAWN) or (c.cutscene == CUTSCENE_ENTER_BOWSER_ARENA)) then
        disable_time_stop_including_mario()
        m.freeze = 0
        if c.cutscene == CUTSCENE_ENTER_BOWSER_ARENA then
          local bowser = obj_get_first_with_behavior_id(id_bhvBowser)
          if bowser and bowser.oAction == 5 then
            if bowser.oBehParams2ndByte == 0x01 then
              bowser.oAction = 13
            else
              bowser.oAction = 0
            end
            if m.action == ACT_READING_NPC_DIALOG then
              set_mario_action(m, ACT_IDLE, 0)
            end
          end
        elseif c.cutscene == CUTSCENE_STAR_SPAWN then -- done here because a lot of hacks hook to this object
          local grand = obj_get_first_with_behavior_id(id_bhvGrandStar)
          if grand then
            grand.oAction = 1
            m.invincTimer = 600 -- 20 seconds is long enough I think
            --obj_become_tangible(grand)
          end
        end
        c.cutscene = 0
        play_cutscene(c)
    elseif m.invincTimer < 30 and c.cutscene ~= 0 and gGlobalSyncTable.mhState == 2 then
        m.invincTimer = 30
    end

    -- Faster Cannon Cutscene
    if c.cutscene == CUTSCENE_PREPARE_CANNON then
      play_cutscene(c)
    end

end

--Always Have Cap
---@param m MarioState
local function before_mario_update(m)
  if m.playerIndex ~= 0 then return end
  m.flags = m.flags | MARIO_CAP_ON_HEAD
end

hook_event(HOOK_BEFORE_MARIO_UPDATE, before_mario_update)
hook_event(HOOK_UPDATE, update)










-- On Level Change

local reloadCheck = gGlobalSyncTable.level

function level_init()

    gMarioStates[0].health = 0x800
    
    if gGlobalSyncTable.level == 0 then
        play_sound(SOUND_MENU_MARIO_CASTLE_WARP2, gMarioStates[0].marioObj.header.gfx.cameraToObject)
        reloadCheck = 0
    elseif
        not gGlobalSyncTable.reload and
        reloadCheck ~= gGlobalSyncTable.level
    then
        play_sound(SOUND_GENERAL_RACE_GUN_SHOT, gMarioStates[0].marioObj.header.gfx.cameraToObject)
        reloadCheck = gGlobalSyncTable.level
    end

end

hook_event(HOOK_ON_LEVEL_INIT, level_init)